def proc display_grid
rem display the grid, for each line in turn, show the corresponding
rem sprite at each column
local lines%,columns%,lp2%,xo%,yo%,my_sprite,t%,xoff%,xso%(3)
  yo%=yorig%
  if can_show_mol%
    xoff%=0
  else
    xoff%=15*sp_size%
    xoff%=(xsize%-8-xoff%) /2
  endif
  xoffset%=xoff%
  for lines%=0 to max_lines%
    rem xo%=xorig%		    : rem restart at first column
    if walls%(current_level%,lines%,0)<0 or walls%(current_level%,lines%,1)<0
	yo%=yo%+sp_size%
	next lines%:exit lines%
    endif
    xo%=xoff%+walls%(current_level%,lines%,0)*sp_size%
    for columns%= walls%(current_level%,lines%,0) to walls%(current_level%,lines%,1)
      t%=grid%(lines%,columns%) : rem what kind of sprite to display?
      select on t%
	=-5
	   wsprt#mnch%,xo%,yo%,boden_sprite
	   my_sprite=sp_left
	=-4
	   wsprt#mnch%,xo%,yo%,boden_sprite
	   my_sprite=sp_down
	=-3
	   wsprt#mnch%,xo%,yo%,boden_sprite
	   my_sprite=sp_right
	=-2
	   wsprt#mnch%,xo%,yo%,boden_sprite
	   my_sprite=sp_up
	=-1
	   my_sprite=wall_sprite
	=0
	   my_sprite=boden_sprite
	=remainder:
	   display_atom xo%,yo%,t%
	   my_sprite=0
      end select
      if my_sprite:wsprt#mnch%,xo%,yo%,my_sprite
      xo%=xo%+sp_size%		: rem move one column to the left
    end for columns%		: rem do for all comlumns
    yo%=yo%+sp_size%		: rem move one line further down
  end for lines%		: rem do for all lines
  if can_show_mol%
    wsipo#mnch%,xso%
    lines%=(mole_lines%(current_level%)+1)*sp_size% +8
    xoff%=(xso%(0)-15*sp_size%-molxs%-4) div 2	+15*sp_size%+2
    window#mnch%,molxs%+4,lines%,xso%(2)+xoff%,xso%(3)+((xso%(1)-lines%) div 2)
    wm_border#mnch%,2,sp.infwinbd
    display_mole
    set_app_wdw 0
  endif
end def display_grid
:
def proc display_atom (xo%,yo%,atom_to_display%)
rem display one atom by writing the appropriate sprite and bound sprite(s)
local lp%,temp%,t%
  temp%=atoms%(current_level%,atom_to_display%) : rem type of atom to display
  wsprt #mnch%,xo%,yo%,boden_sprite
  wsprt #mnch%,xo%,yo%,atom_sprite(temp%-1)    : rem corresponding sprite
  for lp%= 1 to 8
    t%= atom_bounds%(current_level%,atom_to_display%,lp%)
    if t%<>-1:wsprt #mnch%,xo%,yo%,bound_sprite(t%)
  end for lp%
end def display_atom
:
def proc erase_pointers
local lp%
  for lpy%=0 to 3
    if pointers%(lpy%,0)<>0 and  pointers%(lpy%,1)<>0
       wsprt#mnch%,pointers%(lpy%,1)*sp_size%+xoffset%,pointers%(lpy%,0)*sp_size%+yorig%,boden_sprite
       grid%(pointers%(lpy%,0),pointers%(lpy%,1))=0
    endif
  end for lpy%
  dim pointers%(4,2)
end def erase_pointers
:
def proc display_pointers
local lp%,pt%,my_sprite
  for lpy%=0 to 3
    if pointers%(lpy%,0)<>0 and  pointers%(lpy%,1)<>0
       pt%=grid%(pointers%(lpy%,0),pointers%(lpy%,1))
       select on pt%
	 =-5
	     my_sprite=sp_left
	  =-4
	     my_sprite=sp_down
	  =-3
	     my_sprite=sp_right
	  =-2
	     my_sprite=sp_up
	=remainder:
	   my_sprite=0
      end select
      if my_sprite
	wsprt#mnch%,xoffset%+pointers%(lpy%,1)*sp_size%,pointers%(lpy%,0)*sp_size%+yorig%,boden_sprite
	wsprt#mnch%,xoffset%+pointers%(lpy%,1)*sp_size%,pointers%(lpy%,0)*sp_size%+yorig%,my_sprite
      endif
    endif
  end for lpy%
end def display_pointers
:
def proc display_mole
local lines%,columns%,lp2%,xo%,yo%,my_sprite,t%,sz%(3),xorg%
  cls#mnch%
  wsipo#mnch%,sz%		: rem winwdw size/pos
  yo%=(sz%(1)-sp_size%*(mole_lines%(current_level%)+1))/2
  xorg%=(sz%(0)-sp_size%*(mole_lengths%(current_level%)+1))/2
  for lines%=0 to mole_lines%(current_level%)
    xo%=xorg%		       : rem restart at first column
    for columns%= 0 to mole_lengths%(current_level%)
      t%=mole%(lines%,columns%) : rem what kind of sprite to display?
      select on t%
	=0
	   my_sprite=boden_sprite
	=remainder:
	   display_atom xo%,yo%,t%
	   my_sprite=0
      end select
      if my_sprite:wsprt#mnch%,xo%,yo%,my_sprite
      xo%=xo%+sp_size%		: rem move one column to the left
    end for columns%		: rem do for all comlumns
    yo%=yo%+sp_size%		: rem move one line further down
  end for lines%		: rem do for all lines
end def display_mole
:
def proc get_and_show_current_level
local xabs%
  read_level
  moves%=0
  set_info_wdw 1
  make_mol_wdw
  xabs%=xsize%-12-15*sp_size%		 : rem space remaining
  can_show_mol%= xabs%>molxs%
  set_app_wdw 1
  display_grid
  if not can_show_mol%
    show_mol
  endif
end def get_and_show_current_level
:
