def proc handle_appsub_click
rem click in appsub wdw, check whether we clicked on an atmo,
rem if yes, show handles
rem if no check whether we hit a handle, move atom if yes
local x%,y%,temp%
  x%=(xrel%-xoffset%) div sp_size%
  y%=yrel% div sp_size% 	: rem x,y oords in grid
  if x%<0 or y%<0 or x%>max_cols% or y%>max_lines%:return
  temp%=grid%(y%,x%): rem what is beneath
  select on temp%
    =-5,-4,-3,-2 : click_on_handle x%,y%,temp%
    =-1,0
    = remainder: click_on_atom x%,y%
  end select
end def handle_appsub_click
:
def proc click_on_atom (x%,y%)
rem click on a atom, show the available handles
local lpy%
  rem first of all, erase old handles
  erase_pointers
  rem check for handles for this atom
  lpy%=0
  if y%>1
    if not grid%(y%-1,x%)
       grid%(y%-1,x%)=-2
       pointers%(lpy%,0)=y%-1
       pointers%(lpy%,1)=x%
       lpy%=lpy%+1
     endif
  endif
  if y%<15
    if not grid%(y%+1,x%)
       grid%(y%+1,x%)=-4
       pointers%(lpy%,0)=y%+1
       pointers%(lpy%,1)=x%
       lpy%=lpy%+1
     endif
  endif
  if x%>1
    if not grid%(y%,x%-1)
       grid%(y%,x%-1)=-5
       pointers%(lpy%,0)=y%
       pointers%(lpy%,1)=x%-1
       lpy%=lpy%+1
     endif
  endif
  if x%<15
    if not grid%(y%,x%+1)
       grid%(y%,x%+1)=-3
       pointers%(lpy%,0)=y%
       pointers%(lpy%,1)=x%+1
     endif
  endif
  display_pointers
end def click_on_atom
:
def proc click_on_handle (x%,y%,direction%)
  erase_pointers
  ch_ptr main_defn,0,empty_sprite
  select on direction%
    = -5   : slide_left
    = -4   : slide_down
    = -3   : slide_right
    = -2   : slide_up
  end select
  ch_ptr main_defn,0,cursor_sprite
  moves%=moves%+1
  set_info_wdw 1		: rem show nbr of moves
  set_app_wdw 0
  if puzzle_finished% :ask_yes_no
end def click_on_handle
:
