def proc load_solutions (file$)
rem input a solutions file where the solution is in a line history
rem such as
rem    "history": "efhfhfhbejdjdjdmdmimiiihihghimihihhhhhhcfcgcghgdgcgbhcfcgdhdhbhchcgcjdjbjbhbhbhchdgd",
local chan%,lp%,a$,counter%,t%
  dim solutions$(maxpuzzle%,1000)
  chan%=fop_in(file$)
  if chan%<0:return
  counter%=1
  rep lp%
    if eof(#chan%):exit lp%
    a$=strip_spaces$(gline$(#chan%))
    if a$="":next lp%			: rem empty lline do next
    if '"history":' instr a$
      if len(a$)<16:next lp%		: rem what????
      a$=a$(13 to len (a$)-2)		: rem get the interesting bits
      t%=len(a$)
      t%=t% mod 4			: rem length must be a multiple of 4
      if not t%:solutions$(counter%)=a$
      counter%=counter%+1
    endif
  end rep lp%
  close#chan%
end def load_solution
:
def proc apply_solution (level%)
local lp%,temp%,a$,xypos%(3),lp2%,b$,mline%,mcol%
  mline%=get_first_line% (level%)
  mcol%=get_first_col%
  if mline%=-1 or mcol%=-1:return
  b$=solutions$(level%)
  for lp%=1 to len(b$) step 4
    a$=b$(lp% to lp%+3)
    for lp2%=0 to 3
      xypos%(lp2%)=get_nbr%(a$(lp2%+1))
      if xypos%(lp2%)=-1:return
    end for lp2%
    xypos%(0)=xypos%(0)+mline%
    xypos%(2)=xypos%(2)+mline%
    xypos%(1)=xypos%(1)+mcol%
    xypos%(3)=xypos%(3)+mcol%
    temp%=grid%(xypos%(0),xypos%(1))
    if grid%(xypos%(2),xypos%(3))<>0:next lp%:exit lp% : rem WHAT???????
    grid%(xypos%(0),xypos%(1))=0
    grid%(xypos%(2),xypos%(3))=temp%
    display_grid
    pause#mnch%, 10
  end for lp%
  if puzzle_finished%:ask_yes_no
end def apply_solution
:
def fn get_nbr%(a$)
rem converts lower cased letter a...o (in a$ at piace%) to 0...14
rem returns -1 if error
local lp%,temp%
  temp%=code(a$(1))
  select on temp%
     =97 to 97+14:return temp%-97
     =remainder:return -1
  end select
end def get_nbr%
:
def fn get_first_col%
rem gets the number of the first column where htere is someting other than empty space
local lines%,cols%,a$,lp2%,res%
  res%=15
  for cols%=0 to 14
     for lines%=0 to 14
       if grid%(lines%,cols%)<>0
	  if res%>cols%
	     res%=cols%
	  endif
	  next cols%:exit cols%
       endif
     end for lines%
  end for cols%
  if res%=15:return -1
  return res%
end def get_first_col%
:
def fn get_first_line%(level%)
  local lp%
  for lp%=0 to 14
    if walls%(level%,lp%,0)<> -1 and walls%(level%,lp%,1)<>0: return lp%
  end for lp%
  return -1
end def get_first_line%
:
